<?php

namespace BancoTalentos\Controllers;

use BancoTalentos\Services\OperadorService;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class OperadorController {

    public function __construct(OperadorService $operadorService) {
        $this->operadorService = $operadorService;
    }

    public function setOperadorAcesso(DTO\Request\row $request, DTO\Response $response) {
        try {
            $row = $request->getRow()->getArrayCopy();

           $this->operadorService->setOperadorAcesso($row);

            $response->addDataSet(new DataSet('data', array(true)));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

}