<?php

namespace BancoTalentos\Services;

use BancoTalentos\Repositories\PessoaRepository;
use BancoTalentos\Util\{BTParameters, Repositories, Service };
use BancoTalentos\Services\PessoaService;

class PessoaHService extends Service {
    /** @var BTParameters */
    protected $btParameters;

    /** @var PessoaService */
    protected $pessoaService;

    /** @var PessoaRepository */
    protected $pessoaRepository;

    public function __construct(
        BTParameters $btParameters,
        PessoaService $pessoaService,
        PessoaRepository $pessoaRepository
    ) {
        $this->btParameters = $btParameters;
        $this->pessoaService = $pessoaService;
        $this->pessoaRepository = $pessoaRepository;
    }

    public function getEntityRepositoryName(): string {
        return Repositories::GPE_PESSOAH;
    }

    public function getEntityKeysName(): array {
        return [
            'NRORG',
            'NRPESSOAH',
        ];
    }

    public function getPessoaByNrParcNegocio(
        int $nrParcNegocio
    ) {
        $nrOrg = (int) $this->btParameters->getNrOrg();

        $pessoaArray = $this->pessoaRepository->getPessoaByNrParcNegocio(
            $nrOrg, $nrParcNegocio
        );

        return $pessoaArray;
    }
}