<?php

namespace tests\mocks;

use Doctrine\ORM\EntityManagerInterface;
use Doctrine\ORM\Query\ResultSetMapping;

class EntityManagerMock implements EntityManagerInterface {
    
    /* Structures created for testing */

    private $flushed = false;

    public function isFlushed() {
        return $this->flushed;
    }

    public function resetFlushed() {
        $this->flushed = false;
    }

    private $persisted = false;

    public function isPersisted() {
        return $this->persisted;
    }

    public function resetPersisted() {
        $this->persisted = false;
    }

    private $removed = false;

    public function isRemoved() {
        return $this->removed;
    }

    public function resetRemoved() {
        $this->removed = false;
    }

    public function __construct() {
        $this->objectRepositoryMock = new ObjectRepositoryMock();
    }

    public function setExistingDataForTests(array $data = null) {
        $this->objectRepositoryMock->setExistingDataForTests($data);
    }

    public function getExistingDataForTests(): ?array {
        return $this->objectRepositoryMock->getExistingDataForTests();
    }

    /* Methods declared in EntityManagerInterface */

    public function getCache() {}

    public function getConnection() {}

    public function getExpressionBuilder() {}

    public function beginTransaction() {}

    public function transactional($func) {}

    public function commit() {}

    public function rollback() {}

    public function createQuery($dql = '') {}

    public function createNamedQuery($name) {}

    public function createNativeQuery($sql, ResultSetMapping $rsm) {}

    public function createNamedNativeQuery($name) {}

    public function createQueryBuilder() {}

    public function getReference($entityName, $id) {}

    public function getPartialReference($entityName, $identifier) {}

    public function close() {}

    public function copy($entity, $deep = false) {}

    public function lock($entity, $lockMode, $lockVersion = null) {}

    public function getEventManager() {}

    public function getConfiguration() {}

    public function isOpen() {}

    public function getUnitOfWork() {}

    public function getHydrator($hydrationMode) {}

    public function newHydrator($hydrationMode) {}

    public function getProxyFactory() {}

    public function getFilters() {}

    public function isFiltersStateClean() {}

    public function hasFilters() {}

    /* Methods declared in ObjectManager */

    public function find($className, $id) {}

    public function persist($object) { $this->persisted = true; }

    public function remove($object) { $this->removed = true; }

    public function merge($object) {}

    public function clear($objectName = null) {}

    public function detach($object) {}

    public function refresh($object) {}

    public function flush() { $this->flushed = true; }

    public function getRepository($className) { return $this->objectRepositoryMock; }

    public function getClassMetadata($className) {}

    public function getMetadataFactory() {}

    public function initializeObject($obj) {}

    public function contains($object) {}
}