#!/bin/bash

SCRIPTS_PATH=$('pwd')
MCSV_PATH=$('pwd')/../
DEVOPS_VERSION="0"
DEVOPS_REVISION="25"
DEVOPS_BUILD="0"
PACKAGE_VERSION="$DEVOPS_VERSION.$DEVOPS_REVISION.$DEVOPS_BUILD"
REVISION_DATE=$(date +%s)

LOCAL_URL="https://talentos.teknisa.com/"

echo 'Update version package.json ----------------------------------------------------'
cd $MCSV_PATH/mobile
$SCRIPTS_PATH/replace.sh '"version": "0.1.0"' '"version": "'$PACKAGE_VERSION'"' "package.json"

echo 'Update PROJECT_URL ----------------------------------------------------'
cd $MCSV_PATH/backend/config
$SCRIPTS_PATH/replace.sh '<>PROJECT_URL<>' "${LOCAL_URL}" "environment.xml.template"
echo $LOCAL_URL
cat environment.json.template

echo 'Front Step --------------------------------------------------------------'
cd $MCSV_PATH/mobile
$SCRIPTS_PATH/front_step.sh

echo 'Run Grunt Tasks For Production -------------------------------------------'
grunt init_project
grunt buildEnvironment:production

echo 'Update Package Version Constants.ts ----------------------------------------------------'
cd $MCSV_PATH/mobile/src/assets/ts/configuration/
$SCRIPTS_PATH/replace.sh "<>PRODUCT_VERSION<>" $PACKAGE_VERSION "Constants.ts"

echo 'Building application frontend ---------------------------------------------'
cd $MCSV_PATH/mobile
{
    npm run build
} || {
   echo 'Build Error ---------------------------------------------------------------'
   exit 1
}

echo 'Back Step --------------------------------------------------------------'
cd $MCSV_PATH/backend
rm -v index.php
$SCRIPTS_PATH/back_step.sh $DEVOPS_VERSION $DEVOPS_REVISION $DEVOPS_BUILD

echo 'Update Package Version ---------------------------------------------------'
cd $MCSV_PATH/backend/config
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "parameters.xml"

echo 'Remove Development Dependencies ------------------------------------------'
rm -f $MCSV_PATH/mobile/.bowerrc
rm -f $MCSV_PATH/mobile/bower.json
rm -f $MCSV_PATH/mobile/GruntFile.js
rm -f $MCSV_PATH/README.md

rm -Rf $MCSV_PATH/mobile/config

cd $MCSV_PATH
mv mobile/ mobile_delete/
mkdir mobile/
mv mobile_delete/dist/* mobile/
mv mobile_delete/assets mobile/
rm -Rf mobile_delete

echo 'Remove all .git folders --------------------------------------------------'
cd $SCRIPTS_PATH/../
#find . -name .git -exec rm -rf {} +

echo 'Create modules folder ----------------------------------------------------'
cd $MCSV_PATH
rm -Rf ./modules
mkdir -p ./modules/
mkdir -p ./modules/teknisa

echo 'COMPOSER DUMP-AUTOLOAD -----------------------------------'
cd $MCSV_PATH/backend/
composer dump-autoload

echo 'ls mobile ------------------------------------------------'
ls -a $MCSV_PATH/mobile
